/* 
 * File:   i2c.c
 * Author: alxlabs
 *
 * Created on July 27, 2019, 10:03 AM
 */

#include <xc.h>
#include "init_a.h"
void SetSCL (void)
{
    PORTCbits.RC0 = 1;
}

void ClrSCL (void)
{
    PORTCbits.RC0 = 0;
}

void SetSDA (void)
{
    PORTCbits.RC1 = 1;
}

void ClrSDA (void)
{
    PORTCbits.RC1 = 0;
}

void SendSTART(void)
{
    ClrSDA();
    ClrSCL();
}

void SendSTOP(void)
{
    SetSCL();
    SetSDA();
}

void GetACK(void)
{
    /***
     This is dummy, I'm not interested in checking ACKs for this project
     ***/
    SetSDA();
    SetSCL();
    ClrSCL();
    ClrSDA();
}

void SendACK(void)
{
    ClrSDA();
    SetSCL();
    ClrSCL();
    ClrSDA();
}

void SendBIT(unsigned char ucBit)
{
    if (ucBit)
    {
        SetSDA();
    }
    else
    {
        ClrSDA();
    }
    SetSCL();
    ClrSCL();
    ClrSDA();
}

unsigned char GetBIT(void)
{
    unsigned char ucBit;
    ucBit = 0;
    
    SetSDA();
    SetSCL();
    if (PORTC & 0x04)
    {
        ucBit = 1;
    }
    ClrSCL();
    ClrSDA();
    return (ucBit);
}

void SendByte(unsigned char ucByte)
{
    unsigned char ucCntr;
    
    ucCntr = 0;
    
    for (ucCntr = 0; ucCntr <8; ucCntr++)
    {
        if (0x80&ucByte)
        {
            SendBIT(TRUE);
        }
        else
        {
            SendBIT(FALSE);
        }
        ucByte = ucByte << 1;
    }
}

unsigned char GetByte(void)
{
    unsigned char ucRet;
    unsigned char ucCntr;
    ucCntr = 0;
    ucRet = 0;
    
    for (ucCntr = 0; ucCntr < 8; ucCntr++)
    {
        ucRet = ucRet << 1;
        if (GetBIT())
        {
            ucRet = ucRet | 0x01;
        }
        else
        {
            ucRet = ucRet & 0xFE;
        }
    }
    return (ucRet);
}