/* 
 * File:   init_a.h
 * Author: alxlabs
 *
 * Created on July 27, 2019, 10:11 AM
 */

#ifndef INIT_A_H
#define	INIT_A_H

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif

#define TRUE        1
#define FALSE       0
#define CBR19200    25
#define SLEEPMX     0xFFFF
#define SLEEPSTD    1000
#define SLAVEWR     0xee
#define SLAVERD     0xef
#define REGID       0xd0
#define ALLOK       0x60
#define REGRESET    0xe0
#define GOAHEAD     0xb6
#define INITDELAY   3
#define CTRL_HUM    0xf2
#define HUMSTD      0x01
#define CTRL_MEAS   0xf4
#define CALC_NUM    0xf7
#define STD_MEAS    0x27
#define STARTADDR   0x88
#define TOTALRD     0x77
#define SPLITSZ     0x40
#define INTERMSLEEP 10
#define AL_CR       0x0d
#define AL_LF       0x0a
#define SLEEPTR     2000
#define SLEEPTR_SM  20
#define CALC_PACK   8

#define MPOWER      PORTBbits.RB4
#define MFAST       PORTBbits.RB5

#pragma config FOSC = INTRCCLK  // Oscillator Selection bits (INTOSC oscillator: CLKOUT function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled and can be enabled by SWDTEN bit of the WDTCON register)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = OFF      // MCLR Pin Function Select bit (MCLR pin function is digital input, MCLR internally tied to VDD)
#pragma config CP = OFF         // Code Protection bit (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)
#pragma config BOREN = OFF      // Brown-out Reset Selection bits (BOR disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enabled bit (Fail-Safe Clock Monitor is disabled)

extern void init(void);
extern void SetSCL (void);
extern void ClrSCL (void);
extern void SetSDA (void);
extern void ClrSDA (void);
extern void SendSTART(void);
extern void SendSTOP(void);
extern void GetACK(void);
extern void SendACK(void);
extern void SendBIT(unsigned char ucBit);
extern unsigned char GetBIT(void);
extern void SendByte(unsigned char ucByte);
extern unsigned char GetByte(void);
#endif	/* INIT_A_H */

