/*
 * File:   mainPICa.c
 * Author: alxlabs
 *
 * Created on July 27, 2019, 9:52 AM
 */

#include <xc.h>
#include "init_a.h"

const unsigned char ucTxMessage[]={"alxlabs."};
const unsigned char ucEmpyResp[] = {0x80, 0x00, 0x00, 0x80, 0x00, 0x00, 0x80, 0x00};
unsigned char ucXTRData[8];

void putchar (unsigned char a)
{
	while (TXIF == 0x00);
	TXREG = a;
	while (TXIF == 0x00);
}

void xsleep (unsigned int uiSleep)
{
    while (uiSleep--);
}
void xtraSleep(unsigned int uiSleep)
{
    while (uiSleep--)
    {
        xsleep(SLEEPMX);
    }
}

void main(void) 
{
    unsigned char ucDat;
    unsigned char ucPtr;
    unsigned char ucFail;
    unsigned char ucCRC;
    
    ucPtr = 0x00;
    ucDat = 0x00;

    init();
    xsleep (SLEEPSTD);
    while (TRUE)
    {   
        MPOWER = 1;
        xtraSleep(INTERMSLEEP);
        ucCRC = 0;
        SendSTART();
        SendByte(SLAVEWR); //slave address = 0xee
        GetACK();
        SendByte(REGID); //actual data
        GetACK();
        SendSTOP();
       
        SendSTART();
        SendByte(SLAVERD);
        GetACK();

        ucDat = GetByte();
        SendSTOP();
        
        ucPtr = 0x00;
        while ('.' != ucTxMessage[ucPtr])
        {
            putchar(ucTxMessage[ucPtr++]);
        }
        if (ALLOK == ucDat)
        {
            putchar('O');
        }
        else
        {
            putchar('E');
        }

        /**************** 
         **Reset sensor**
         ****************/
        SendSTART();
        SendByte(SLAVEWR);
        GetACK();
        SendByte(REGRESET); //e0
        GetACK();
        SendByte(GOAHEAD); //b6
        GetACK();
        SendSTOP();
        xtraSleep(INITDELAY);
        
        /**************** 
         ** Init sensor**
         ****************/
        SendSTART();
        SendByte(SLAVEWR);
        GetACK();
        SendByte(CTRL_HUM);//f2
        GetACK();
        SendByte(HUMSTD); //01
        GetACK();
        SendSTOP();
        
        SendSTART();
        SendByte(SLAVEWR);
        GetACK();
        SendByte(CTRL_MEAS);//f4
        GetACK();
        SendByte(STD_MEAS); //27
        GetACK();
        SendSTOP();

        SendSTART();
        SendByte(SLAVEWR);
        GetACK();
        SendByte(STARTADDR);
        GetACK();
        SendSTOP();
        
        /************************** 
         **Reading data 0x88-0xfe**
         *************************/
        SendSTART();
        SendByte(SLAVERD);
        GetACK();
        for (ucPtr = 0x00; ucPtr < TOTALRD; ucPtr++)
        {
            ucDat = GetByte();
            SendACK();
            putchar(ucDat);
            ucCRC += ucDat;
            
            if (SPLITSZ == ucPtr)
            {
                xtraSleep(INTERMSLEEP);
            }
        }
        SendSTOP();
                
        ucFail = TRUE;
        
        while (ucFail)
        {
            SendSTART();
            SendByte(SLAVEWR);
            GetACK();
            SendByte(CALC_NUM);
            GetACK();
            SendSTOP();
        
            SendSTART();
            SendByte(SLAVERD);
            GetACK();
            for (ucPtr = 0x00; ucPtr < CALC_PACK; ucPtr++)
            {
                ucXTRData[ucPtr] = GetByte();
                SendACK();
            }
            SendSTOP();
            
            for (ucPtr = 0; ucPtr < 8; ucPtr++)
            {
    			if (ucXTRData[ucPtr] != ucEmpyResp[ucPtr])
    			{
    				ucFail = FALSE;
    			}
    		}
        }
        for (ucPtr = 0; ucPtr < 8; ucPtr++)
        {
            putchar(ucXTRData[ucPtr]);
            ucCRC += ucXTRData[ucPtr];
   		}
        putchar (ucCRC);
        putchar(AL_CR);
        putchar(AL_LF);
        
        xtraSleep(INTERMSLEEP);
        
        if (MFAST)
        {
            MPOWER = 0;
            xtraSleep(SLEEPTR);
        }
        else
        {
            MPOWER = 1;
            xtraSleep(SLEEPTR_SM);
        }
   }
   return;
}
